package com.Main;

import java.io.InputStream;
import java.util.Properties;
import java.util.concurrent.TimeUnit;
import com.fetchFile.FetchReportFile;
import com.sendFile.protocol.SSH.SSHProtocol;

public class Main {
  public static void main(String[] args) {
    String user = "";
    String password = "";
    String hostUcb = "";
    String hostNabard = "";
    String local_folder_path = "";
    String local_archive_path = "";
    String local_report_path = "";
    String local_report_bkp_path = "";
    String remote_file_path = "";
    String remote_report_path = "";
    String remote_report_pattern = "";
    String transfer_protocol = "";
    String remote_failed_path = "";
    String local_failed_path = "";
    String local_fileName = "";
    String remote_fileName = "";
    String dbUrl = "";
    String dbUsr = "";
    String dbPass = "";
    String dbSchema = "";
    int port = 22;
    long sleep = 5L;

    try {
      InputStream input = Main.class.getClassLoader().getResourceAsStream("config.properties");
      Properties prop = new Properties();
      if (input == null) {
        System.out.println("Sorry, unable to find config.properties");
        return;
      }
      prop.load(input);

      hostUcb = prop.getProperty("REMOTE_HOST_UCB");
      hostNabard = prop.getProperty("REMOTE_HOST_NABARD");
      user = prop.getProperty("REMOTE_USER");
      password = prop.getProperty("REMOTE_PASS");
      port = Integer.parseInt(prop.getProperty("REMOTE_PORT"));
      sleep = Long.parseLong(prop.getProperty("SLEEP_TIME_MINS"));
      local_folder_path = prop.getProperty("LOCAL_FOLDER_PATH");
      local_archive_path = prop.getProperty("ARCHIVE_FOLDER_PATH");
      local_report_path = prop.getProperty("LOCAL_REPORT_PATH");
      local_report_bkp_path = prop.getProperty("LOCAL_REPORT_BKP_PATH");
      remote_file_path = prop.getProperty("REMOTE_INPUT_FILE_PATH");
      remote_report_path = prop.getProperty("REMOTE_OUTPUT_FILE_PATH");
      transfer_protocol = prop.getProperty("TRANSFER_PROTOCOL");
      remote_report_pattern = prop.getProperty("REMOTE_REPORT_PATTERN");
      remote_failed_path = prop.getProperty("REMOTE_FAILURE_FILE_PATH");
      local_failed_path = prop.getProperty("LOCAL_FAILED_PATH");
      dbUrl = prop.getProperty("DB_URL");
      dbUsr = prop.getProperty("DB_USER");
      dbPass = prop.getProperty("DB_PASS");
      dbSchema = prop.getProperty("DB_SCHEMA");

      System.out.println("Config Properties read:");
      System.out.println(
          "REMOTE_HOST_UCB: "
              + hostUcb
              + "\nREMOTE_HOST_NABARD: "
              + hostNabard
              + "\nREMOTE_USER: "
              + user
              + "\nREMOTE_PASS: "
              + password
              + "\nREMOTE_PORT: "
              + port
              + "\nREMOTE_FILE_PATH: "
              + remote_file_path
              + "\nSLEEP_TIME: "
              + sleep
              + "\nLOCAL_FOLDER_PATH: "
              + local_folder_path
              + "\nTRANSFER_PROTOCOL: "
              + transfer_protocol);

    } catch (Exception e) {
      e.printStackTrace();
    }

    SSHProtocol send =
        new SSHProtocol(
            user,
            password,
            hostUcb,
            hostNabard,
            port,
            local_fileName,
            "",
            remote_file_path,
            remote_fileName,
            local_archive_path,
            local_folder_path,
            dbUrl,
            dbUsr,
            dbPass,
            dbSchema);
    FetchReportFile fetch =
        new FetchReportFile(
            user,
            password,
            hostUcb,
            hostNabard,
            local_report_path,
            local_report_bkp_path,
            remote_report_path,
            transfer_protocol,
            port,
            remote_report_pattern,
            dbUrl,
            dbUsr,
            dbPass);
    FetchReportFile fetchFailed =
        new FetchReportFile(
            user,
            password,
            hostUcb,
            hostNabard,
            local_failed_path,
            "",
            remote_failed_path,
            transfer_protocol,
            port,
            remote_report_pattern,
            dbUrl,
            dbUsr,
            dbPass);

    try {
      while (true) {
        System.out.println("___________________________________________________");
        try {
          send.sendFileSSHUcb();
          send.sendFileSSHNabard();
        } catch (Exception e) {
          e.printStackTrace();
        }
        try {
          fetch.fetchFiles();
        } catch (Exception e) {
          e.printStackTrace();
        }
        try {
          fetchFailed.fetchFiles();
        } catch (Exception e) {
          e.printStackTrace();
        }

        System.out.println("Sleeping for:" + sleep + " Minutes");
        System.out.println("___________________________________________________");
        TimeUnit.MINUTES.sleep(sleep);
      }

    } catch (Exception e) {

      System.out.println(e);
      return;
    }
  }
}
