package com.fetchFile;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import com.sendFile.protocol.FTP.FTPProtocol;
import com.sendFile.protocol.SSH.SSHProtocol;

public class FetchReportFile {
  String user;
  String password;
  String hostUcb;
  String hostNabard;
  String local_folder_path;
  String local_folder_path_bkp;
  String remote_file_path;
  String transfer_protocol;
  String remote_report_pattern;
  String dbUrl;
  String dbUsr;
  String dbPass;
  String dbSchema;
  final DateFormat sdf = new SimpleDateFormat("ddMMyyyy");
  Calendar cal = Calendar.getInstance();

  int port;

  public FetchReportFile(
      String user,
      String password,
      String hostUcb,
      String hostNabard,
      String local_folder_path,
      String local_report_bkp_path,
      String remote_file_path,
      String transfer_protocol,
      int port,
      String remote_report_pattern,
      String dbUrl,
      String dbUsr,
      String dbPass) {
    this.user = user;
    this.password = password;
    this.hostUcb = hostUcb;
    this.hostNabard = hostNabard;
    this.local_folder_path = local_folder_path;
    this.local_folder_path_bkp = local_report_bkp_path;
    this.remote_file_path = remote_file_path;
    this.transfer_protocol = transfer_protocol;
    this.port = port;
    this.remote_report_pattern = remote_report_pattern;
    this.dbUrl = dbUrl;
    this.dbUsr = dbUsr;
    this.dbPass = dbPass;
  }

  public void fetchFiles() {
    if (this.transfer_protocol.equals("SSH")) {
      SSHProtocol ssh =
          new SSHProtocol(
              this.user,
              this.password,
              this.hostUcb,
              this.hostNabard,
              this.port,
              this.local_folder_path,
              this.local_folder_path_bkp,
              this.remote_file_path,
              "",
              "",
              "",
              this.dbUrl,
              this.dbUsr,
              this.dbPass,
              this.dbSchema);
      ssh.fetchFileSSHUcb(this.remote_report_pattern);
      ssh.fetchFileSSHNabard(this.remote_report_pattern);
    } else if (this.transfer_protocol.equals("FTP")) {
      FTPProtocol ftp =
          new FTPProtocol(
              this.user,
              this.password,
              this.hostUcb,
              this.port,
              this.local_folder_path,
              this.remote_file_path,
              "",
              "");

      ftp.fetchFileFTP(this.remote_report_pattern);
    } else {

      System.out.println("Invalid TRANSFER_PROTOCOL. Must be one of FTP or SSH");
    }
  }
}
