package com.sendFile.protocol.SSH;

import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.Session;
import java.io.File;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Properties;
import java.util.Vector;
import com.moveFile.Movefile;

public class SSHProtocol {
  String user;
  String password;
  String hostUcb;
  String hostNabard;
  int port;
  String local_fileName;
  String local_folder_path_bkp;
  String remote_filePath;
  String remote_fileName;
  String archive_path;
  String local_folder_path;
  String dbUrl;
  String dbUsr;
  String dbPass;
  String dbSchema;

  public SSHProtocol(
      String user,
      String password,
      String hostUcb,
      String hostNabard,
      int port,
      String local_fileName,
      String local_folder_path_bkp,
      String remote_filePath,
      String remote_fileName,
      String archive_path,
      String local_folder_path,
      String dbUrl,
      String dbUsr,
      String dbPass,
      String dbSchema) {
    this.user = user;
    this.password = password;
    this.hostUcb = hostUcb;
    this.hostNabard = hostNabard;
    this.port = port;
    this.local_fileName = local_fileName;
    this.local_folder_path_bkp = local_folder_path_bkp;
    this.remote_filePath = remote_filePath;
    this.remote_fileName = remote_fileName;
    this.archive_path = archive_path;
    this.local_folder_path = local_folder_path;
    this.dbUrl = dbUrl;
    this.dbUsr = dbUsr;
    this.dbPass = dbPass;
    this.dbSchema = dbSchema;
  }

  public void sendFileSSHUcb() throws SQLException {
    ChannelSftp sftpChannel = null;
    Connection connection = null;
    Session session = null;
    JSch jsch = new JSch();
    String DBfilename = null;
    String bankCode = null;
    String DBfileType = null;
    String DBfileId = null;
    String DCCBCode = null;
    String procDate = null;
    DateFormat sdf = new SimpleDateFormat("ddMMyyyy");
    Calendar cal = Calendar.getInstance();
    String dateToday = sdf.format(cal.getTime());
    ResultSet rs = null;
    PreparedStatement ps = null;
    ResultSet rs2 = null;
    Statement statement = null;
    Statement statement2 = null;
    try {
      System.out.println("Going to SEND files from remote Server via SSH to UCB Server");
      System.out.println(
          "Creating SSH Session: user@host:port |--->"
              + this.user
              + "@"
              + this.hostUcb
              + ":"
              + this.port);
      session = jsch.getSession(this.user, this.hostUcb, this.port);
      session.setPassword(this.password);
      Properties config = new Properties();
      config.put("StrictHostKeyChecking", "no");
      session.setConfig(config);
      System.out.println("Establishing Connection...");
      session.connect();
      System.out.println("Connection established.");

      try {
        Class.forName("oracle.jdbc.driver.OracleDriver");
        connection = DriverManager.getConnection(this.dbUrl, this.dbUsr, this.dbPass);
        connection.setAutoCommit(false);

        if (connection != null) {
          System.out.println("DB Connected..");
        }

        ps =
            connection.prepareStatement(
                "select k.bnk_code,k.file_name,k.file_type,k.file_id,k.dccb_code,k.proc_dt from "
                    + this.dbSchema
                    + ".kcc_sftp_log k where k.proc_stat = 'Y' and k.proc_dt = '"
                    + dateToday
                    + "' and k.remarks = 'FILE GENERATED' AND k.bnk_code NOT IN ('0005', '0021')");
        rs = ps.executeQuery();

        while (rs.next()) {
          int errCount = 0;
          bankCode = rs.getString(1);
          DBfilename = rs.getString(2);
          DBfileType = rs.getString(3);
          DBfileId = rs.getString(4);
          DCCBCode = rs.getString(5);
          procDate = rs.getString(6);
          connection.commit();

          System.out.println("Creating SFTP Channel.");
          sftpChannel = (ChannelSftp) session.openChannel("sftp");
          sftpChannel.connect();
          System.out.println("SFTP Channel created.");
          System.out.println(
              "SFTP -- Local File Name: "
                  + DBfilename
                  + " Remote File Name: "
                  + this.remote_fileName);

          System.out.println(
              "Going to create brancheise folder:" + bankCode + " at " + this.remote_filePath);
          sftpChannel.cd(this.remote_filePath);
          try {
            sftpChannel.mkdir(bankCode);
          } catch (Exception ex) {
            System.out.println("Folder not created: " + ex.getMessage());
          }

          try {
            sftpChannel.cd(bankCode);

            sftpChannel.put(this.local_folder_path + DBfilename, DBfilename);
            System.out.println("File copied to remote server Successfully, archiving file");

            Movefile mv = new Movefile();
            mv.movefile(new File(this.local_folder_path + DBfilename), this.archive_path);
            System.out.println("File archived to: " + this.archive_path);
          } catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("Error pushing file:" + DBfilename);
            errCount++;
          }
          if (errCount == 0) {
            statement2 = connection.createStatement();
            rs2 =
                statement2.executeQuery(
                    "update "
                        + this.dbSchema
                        + ".KCC_SFTP_LOG set proc_stat='S',sftp_remarks='FILE"
                        + " SENT',FILE_SFTP_SND_TIME= to_date(to_char(SYSTIMESTAMP,"
                        + " 'DD-MON-RRHH24:MI:SS'),'DD-MON-RRHH24:MI:SS') where file_name='"
                        + DBfilename
                        + "' and BNK_CODE='"
                        + bankCode
                        + "' and file_id='"
                        + DBfileId
                        + "' and DCCB_CODE='"
                        + DCCBCode
                        + "' and PROC_DT='"
                        + procDate
                        + "' ");
            connection.commit();
            rs2.close();
            System.out.println("File successfully pushed:" + DBfilename);
          }
        }
      } catch (Exception ex) {
        ex.printStackTrace();
      } finally {
        try {
          connection.close();
        } catch (SQLException e1) {
          e1.printStackTrace();
        }
      }
    } catch (Exception ex) {
      ex.printStackTrace();
    } finally {

      try {
        sftpChannel.disconnect();
        session.disconnect();
        System.out.println("Disconnect SFTP Channel");
      } catch (Exception e1) {
        e1.printStackTrace();
      }
    }
  }

  public void sendFileSSHNabard() throws SQLException {
    ChannelSftp sftpChannel = null;
    Connection connection = null;
    Session session = null;
    JSch jsch = new JSch();
    String DBfilename = null;
    String bankCode = null;
    String DBfileType = null;
    String DBfileId = null;
    String DCCBCode = null;
    String procDate = null;
    DateFormat sdf = new SimpleDateFormat("ddMMyyyy");
    Calendar cal = Calendar.getInstance();
    String dateToday = sdf.format(cal.getTime());
    ResultSet rs = null;
    PreparedStatement ps = null;
    ResultSet rs2 = null;
    Statement statement = null;
    Statement statement2 = null;
    try {
      System.out.println("Going to SEND files from remote Server via SSH to NABARD server");
      System.out.println(
          "Creating SSH Session: user@host:port |--->"
              + this.user
              + "@"
              + this.hostNabard
              + ":"
              + this.port);
      session = jsch.getSession(this.user, this.hostNabard, this.port);
      session.setPassword(this.password);
      Properties config = new Properties();
      config.put("StrictHostKeyChecking", "no");
      session.setConfig(config);
      System.out.println("Establishing Connection...");
      session.connect();
      System.out.println("Connection established.");

      try {
        Class.forName("oracle.jdbc.driver.OracleDriver");
        connection = DriverManager.getConnection(this.dbUrl, this.dbUsr, this.dbPass);
        connection.setAutoCommit(false);

        if (connection != null) {
          System.out.println("DB Connected..");
        }

        ps =
            connection.prepareStatement(
                "select k.bnk_code,k.file_name,k.file_type,k.file_id,k.dccb_code,k.proc_dt from "
                    + this.dbSchema
                    + ".kcc_sftp_log k where k.proc_stat = 'Y' and k.proc_dt = '"
                    + dateToday
                    + "' and k.remarks = 'FILE GENERATED' AND k.bnk_code IN ('0005', '0021')");
        rs = ps.executeQuery();

        while (rs.next()) {
          int errCount = 0;
          bankCode = rs.getString(1);
          DBfilename = rs.getString(2);
          DBfileType = rs.getString(3);
          DBfileId = rs.getString(4);
          DCCBCode = rs.getString(5);
          procDate = rs.getString(6);
          connection.commit();

          System.out.println("Creating SFTP Channel.");
          sftpChannel = (ChannelSftp) session.openChannel("sftp");
          sftpChannel.connect();
          System.out.println("SFTP Channel created.");
          System.out.println(
              "SFTP -- Local File Name: "
                  + DBfilename
                  + " Remote File Name: "
                  + this.remote_fileName);

          System.out.println(
              "Going to create brancheise folder:" + bankCode + " at " + this.remote_filePath);
          sftpChannel.cd(this.remote_filePath);
          try {
            sftpChannel.mkdir(bankCode);
          } catch (Exception ex) {
            System.out.println("Folder not created: " + ex.getMessage());
          }

          try {
            sftpChannel.cd(bankCode);

            sftpChannel.put(this.local_folder_path + DBfilename, DBfilename);
            System.out.println("File copied to remote server Successfully, archiving file");

            Movefile mv = new Movefile();
            mv.movefile(new File(this.local_folder_path + DBfilename), this.archive_path);
            System.out.println("File archived to: " + this.archive_path);
          } catch (Exception ex) {
            ex.printStackTrace();
            System.out.println("Error pushing file:" + DBfilename);
            errCount++;
          }
          if (errCount == 0) {
            statement2 = connection.createStatement();
            rs2 =
                statement2.executeQuery(
                    "update "
                        + this.dbSchema
                        + ".KCC_SFTP_LOG set proc_stat='S',sftp_remarks='FILE"
                        + " SENT',FILE_SFTP_SND_TIME= to_date(to_char(SYSTIMESTAMP,"
                        + " 'DD-MON-RRHH24:MI:SS'),'DD-MON-RRHH24:MI:SS') where file_name='"
                        + DBfilename
                        + "' and BNK_CODE='"
                        + bankCode
                        + "' and file_id='"
                        + DBfileId
                        + "' and DCCB_CODE='"
                        + DCCBCode
                        + "' and PROC_DT='"
                        + procDate
                        + "' ");
            connection.commit();
            rs2.close();
            System.out.println("File successfully pushed:" + DBfilename);
          }
        }
      } catch (Exception ex) {
        ex.printStackTrace();
      } finally {
        try {
          connection.close();
        } catch (SQLException e1) {
          e1.printStackTrace();
        }
      }
    } catch (Exception ex) {
      ex.printStackTrace();
    } finally {

      try {
        sftpChannel.disconnect();
        session.disconnect();
        System.out.println("Disconnect SFTP Channel");
      } catch (Exception e1) {
        e1.printStackTrace();
      }
    }
  }

  public void fetchFileSSHUcb(String remote_report_pattern) {
    try {
      System.out.println("Going to FETCH files from remote Server");
      JSch jsch = new JSch();
      System.out.println(
          "Creating SSH Session: user@host:port |--->"
              + this.user
              + "@"
              + this.hostUcb
              + ":"
              + this.port);
      Session session = jsch.getSession(this.user, this.hostNabard, this.port);
      session.setPassword(this.password);

      Properties config = new Properties();
      config.put("StrictHostKeyChecking", "no");
      session.setConfig(config);
      System.out.println("Establishing Connection...");
      session.connect();
      System.out.println("Connection established.");
      System.out.println("Creating SFTP Channel.");
      ChannelSftp sftpChannel = (ChannelSftp) session.openChannel("sftp");
      sftpChannel.connect();
      System.out.println("SFTP Channel created.");

      sftpChannel.cd(this.remote_filePath);
      System.out.println(sftpChannel.pwd());
      String rootPath = sftpChannel.pwd();
      Vector<ChannelSftp.LsEntry> list = sftpChannel.ls(sftpChannel.pwd());

      for (ChannelSftp.LsEntry entry : list) {

        System.out.println(
            "Current File/Folder: " + entry.getFilename() + " isDir " + entry.getAttrs().isDir());
        if (entry.getAttrs().isDir()) {
          if (entry.getFilename().equals(".") || entry.getFilename().equals("..")) {
            System.out.println("Skipping . and ..");
            continue;
          }
          System.out.println("Found folder: " + entry.getFilename());
          System.out.println("cd: " + rootPath + "/" + entry.getFilename());
          sftpChannel.cd(rootPath + "/" + entry.getFilename());
          System.out.println(sftpChannel.pwd());
          Vector<ChannelSftp.LsEntry> subDirFileList = sftpChannel.ls(remote_report_pattern);
          for (ChannelSftp.LsEntry subDirFiles : subDirFileList) {
            if (!(new File(this.local_folder_path_bkp + "/" + subDirFiles.getFilename()))
                .exists()) {
              sftpChannel.get(
                  subDirFiles.getFilename(), this.local_fileName + subDirFiles.getFilename());
              System.out.println(
                  "File: " + subDirFiles.getFilename() + " copied to :" + this.local_fileName);
              continue;
            }
            System.out.println(
                "File: " + subDirFiles.getFilename() + " already present in local path");
          }
        }
      }

      sftpChannel.disconnect();
      session.disconnect();
      System.out.println("Disconnect SFTP Channel");
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  public void fetchFileSSHNabard(String remote_report_pattern) {
    try {
      System.out.println("Going to FETCH files from remote Server");
      JSch jsch = new JSch();
      System.out.println(
          "Creating SSH Session: user@host:port |--->"
              + this.user
              + "@"
              + this.hostNabard
              + ":"
              + this.port);
      Session session = jsch.getSession(this.user, this.hostNabard, this.port);
      session.setPassword(this.password);

      Properties config = new Properties();
      config.put("StrictHostKeyChecking", "no");
      session.setConfig(config);
      System.out.println("Establishing Connection...");
      session.connect();
      System.out.println("Connection established.");
      System.out.println("Creating SFTP Channel.");
      ChannelSftp sftpChannel = (ChannelSftp) session.openChannel("sftp");
      sftpChannel.connect();
      System.out.println("SFTP Channel created.");

      sftpChannel.cd(this.remote_filePath);
      System.out.println(sftpChannel.pwd());
      String rootPath = sftpChannel.pwd();
      Vector<ChannelSftp.LsEntry> list = sftpChannel.ls(sftpChannel.pwd());

      for (ChannelSftp.LsEntry entry : list) {

        System.out.println(
            "Current File/Folder: " + entry.getFilename() + " isDir " + entry.getAttrs().isDir());
        if (entry.getAttrs().isDir()) {
          if (entry.getFilename().equals(".") || entry.getFilename().equals("..")) {
            System.out.println("Skipping . and ..");
            continue;
          }
          System.out.println("Found folder: " + entry.getFilename());
          System.out.println("cd: " + rootPath + "/" + entry.getFilename());
          sftpChannel.cd(rootPath + "/" + entry.getFilename());
          System.out.println(sftpChannel.pwd());
          Vector<ChannelSftp.LsEntry> subDirFileList = sftpChannel.ls(remote_report_pattern);
          for (ChannelSftp.LsEntry subDirFiles : subDirFileList) {
            if (!(new File(this.local_folder_path_bkp + "/" + subDirFiles.getFilename()))
                .exists()) {
              sftpChannel.get(
                  subDirFiles.getFilename(), this.local_fileName + subDirFiles.getFilename());
              System.out.println(
                  "File: " + subDirFiles.getFilename() + " copied to :" + this.local_fileName);
              continue;
            }
            System.out.println(
                "File: " + subDirFiles.getFilename() + " already present in local path");
          }
        }
      }

      sftpChannel.disconnect();
      session.disconnect();
      System.out.println("Disconnect SFTP Channel");
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
